# Stratus - Web Design Platform

[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/Sitetheory/stratus/badges/quality-score.png?b=master)](https://scrutinizer-ci.com/g/Sitetheory/stratus/?branch=master) [![Build Status](https://travis-ci.org/Sitetheory/stratus.svg?branch=master)](https://travis-ci.org/Sitetheory/stratus) [![JavaScript Style Guide](https://img.shields.io/badge/code_style-standard-brightgreen.svg)](https://standardjs.com) [![Join the chat at https://gitter.im/Sitetheory/stratus](https://badges.gitter.im/Sitetheory/stratus.svg)](https://gitter.im/Sitetheory/stratus?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge) [![Greenkeeper badge](https://badges.greenkeeper.io/Sitetheory/stratus.svg)](https://greenkeeper.io/)

## Thesis

This is a minimalistic framework that becomes progressively more complex on-demand.  [Read More...](docs/Thesis.md)

## Goals

* Creative Design
* Code-Free Design
* Elegant Simplicity
* Abstract Extensibility
* Optimal Performance

## Frameworks & Libraries

##### Dependent

* Lodash

##### Recommended

* AMD, CJS, System.js, or equivalent loader

##### Optional

* Angular
* AngularJS
* React

## Usage

#### Deployment

Stratus is built to run within an AMD or equivalent environment with Async/Await or Promises.  For an independent implementation without an asset loader, further functionality involving auto-loading dependencies will not be present, so any javascript dependencies and templates will need to be defined directly on the DOM. 

#### Angular

Angular is in heavy development.  [Read More...](docs/Angular.md)

#### AngularJS

AngularJS is stable and takes additions with ease.  [Read More...](docs/AngularJS.md)

#### React

We don't have any data bindings or Auto-Loading built for React, yet.  [Read More...](docs/React.md)

## Contributions

Always welcome!  [Read More...](docs/Contributing.md)

# License

All information contained herein is, and remains the property of Sitetheory and its suppliers, if any. The intellectual and technical concepts contained herein are proprietary to Sitetheory and its suppliers and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Sitetheory.
